% %
% %	Close goals
% %
% %		Universal quantifiers are added

closeGoals:-
		findall((F,C),getNumberOfGoals(F,C),LFC),
		closeGoalsListOfFiles(LFC).

%%% closeGoalsListOfFiles(in LFC)
%%		LFC: list of pairs (F,C) where
%%		F is the name of the file
%%		C is the number of goals in F
%%		Action: goals are closed

closeGoalsListOfFiles([]).
closeGoalsListOfFiles([(F,C)|LFC]):-
		closeGoalsFile(F,0,C),
		closeGoalsListOfFiles(LFC).

%%% closeGoalsFile(in F, in I, in N)
%%		F: file name
%%		I: index of the last treated goal
%%		N: number of goals
%%		Action: goals are closed

closeGoalsFile(_,N,N):-
		!.
closeGoalsFile(F,I,N):-
		NI is I + 1,
		getGoalKey(F,NI,K),
		!,
		(
		 (
		  1 is NI mod 100,
		  !,
		  print_to_screen('\n'),
		  print_to_screen('\t'),
		  print_to_screen('Current goal --> '),
		  print_to_screen(K),
		  print_to_screen(' 0')
		 );
		 (
		  1 is NI mod 10,
		  !,
		  NI1 is NI // 10,
		  NI2 is NI1 mod 10,
		  print_to_screen(' '),
		  print_to_screen(NI2)
		 );
		 (
		  true
		 )
		),
		getGoal(K,A),
		(
		 (
		  C \= 0,
		  C \= 5,
		  !
		 );
		 (
		  closeGoal(A,NA),
		  setGoal(K,NA)
		 )
		),
		closeGoalsFile(F,NI,N).

%%% closeGoal(in A, out NA)
%%		A: an goal
%%		NA: the closed goal

closeGoal(A,NA):-
		closeFormula(A,LV),
		(
		 (
		  LV = [],
		  !,
		  NA = A
		 );
		 (
		  NA = forall(LV,A)
		 )
		).
