% %
% % Type goals
% %
% %     Type information of variables is included in each goal

typeGoals:-
		findall((F,C),(getNumberOfGoals(F,C), F \= 'automaticCheck'),LFC),
%print_to_screen(LFC),
		typeGoalsListOfFiles(LFC).

%%% typeGoalsListOfFiles(in LFC)
%%%		LFC: list of pairs (F,C) where
%%%%			F is the name of the file
%%%%			C is the number of goals in F
%%%		Action: goals are typed

typeGoalsListOfFiles([]).
typeGoalsListOfFiles([(F,C)|LFC]):-
		typeGoalsFile(F,0,C),
		typeGoalsListOfFiles(LFC).

%%% typeGoalsFile(in F, in I, in N)
%%%		F: file name
%%%		I: index of the last treated goal
%%%		N: number of goals
%%%		Action: goals are typed

typeGoalsFile(_,N,N):-
		!.
typeGoalsFile(F,I,N):-
		NI is I + 1,
		getGoalKey(F,NI,K),
		!,
%print_to_screen(K),
%print_to_screen('\n'),
		(
		 (
		  1 is NI mod 100,
		  !,
		  print_to_screen('\n'),
		  print_to_screen('\t'),
		  print_to_screen('Current goal --> '),
		  print_to_screen(K),
		  print_to_screen(' 0')
		 );
		 (
		  1 is NI mod 10,
		  !,
		  NI1 is NI // 10,
		  NI2 is NI1 mod 10,
		  print_to_screen(' '),
		  print_to_screen(NI2)
		 );
		 (
		  true
		 )
		),
		getGoal(K,A),
		typeGoal(A,NA),
		setGoal(K,NA),
		typeGoalsFile(F,NI,N).

%%% typeGoal(in A, out NA)
%%%		A: an goal
%%%		NA: the typed goal

typeGoal(A,NA):-
		typeFormula(A,NA,[]).
